//Esercitazione di laboratorio n 0
//Terzo quesito
//Si scriva una funzione che riceve una data e calcola la data precedente (modificando
//i tre parametri interi passati per riferimento). Si utilizzino le funzioni ausiliari
//gi sviluppate in classe
#include <iostream>

using namespace std;

unsigned Days ( unsigned , unsigned );
void DataSuccessiva ( unsigned & ,  unsigned & , unsigned & );

int main () {
    unsigned giorno = 29;
    unsigned mese = 2;
    unsigned anno = 2001;
    
    cout << "La data inserita: " << giorno << "/" << mese << "/" << anno << endl;
    
    DataSuccessiva(giorno,mese,anno);
    
    cout << "Il girono successivo: " << giorno << "/" << mese << "/" << anno << endl;
    
    system("pause");
    
    return 0;
}

//Dati in input 2 numeri interi, restituisce il numero dei giorni del mese
//identificato dal primo parametro
unsigned Days ( unsigned mese , unsigned anno ) {
    switch(mese) {
        //Mesi di 30 giorni
        case 4:
        case 6:
        case 9:
        case 11:
            return 30;
            break;
        //Febbraio
        case 2:
            //Faccio il controllo della bisestilit dell'anno
            if(anno % 4 == 0) {
                if(anno % 100 == 0) {
                    if(anno % 400 == 0) 
                        return 29;
                    else
                        return 28;
                }
                else
                    return 29;
            }
            else
                return 28;
            break;
        //Mesi di 31 giorni
        case 1:
        case 3:
        case 5:
        case 7:
        case 8:
        case 10:
        case 12:
            return 31;
            break;
        //Qualsiasi numero che non corrisponda ad un mese
        default:
            return 0;
            break;
    }
}

void DataSuccessiva ( unsigned & giorno ,  unsigned & mese , unsigned & anno ) {
    //Verifico prima che la data esista
    if(anno > 0 && mese > 0 && giorno > 0 && giorno <= Days(mese,anno)) {
        //Aggiungo un giorno alla data
        if(giorno < Days(mese,anno))
            giorno++;
        else {
            if(mese < 12) {
                giorno = 1;
                mese++;
            }
            else {
                giorno = 1;
                mese = 1;
                anno++;
            }
        }
    }
    else
        cerr << "Data inserita non valida!" << endl;
}
