Vettore3D :: Vettore3D ( double x = 0.0 , double y = 0.0 , double z = 0.0 )
{
    x1 = x;
    x2 = y;
    x3 = z;
}

double Vettore3D :: Len ()
{
    return sqrt(x1*x1 + x2*x2 + x3*x3);
}

ostream & operator << ( ostream & os , const Vettore3D & v )
{
    return os << "(" << v.x1 << "," << v.x2 << "," << v.x3 << ")";
}

istream & operator >> ( istream & is , Vettore3D & v )
{
    cout << "x: ";
    is >> v.x1;
    cout << "y: ";
    is >> v.x2;
    cout << "z: ";
    is >> v.x3;
    return is;
}

Vettore3D operator+ ( const Vettore3D & v1 , const Vettore3D & v2 )
{
    Vettore3D v(v1.x1 + v2.x1,v1.x2 + v2.x2,v1.x3 + v2.x3);
    return v;
}

double operator* ( const Vettore3D & v1 , const Vettore3D & v2 )
{
    return ( v1.x1*v2.x1 + v1.x2*v2.x2 + v1.x3*v2.x3 );
}

Vettore3D operator& ( const Vettore3D & v1 , const Vettore3D & v2 )
{
    Vettore3D v;
    v.x1 = v1.x2*v2.x3 - v1.x3*v2.x2;
    v.x2 = v1.x3*v2.x1 - v1.x1*v2.x3;
    v.x3 = v1.x1*v2.x2 - v1.x2*v2.x1;
    return v;
}
