#ifndef VETTORI_HPP
#define VETTORI_HPP

class Vettore3D {
    private:
        double x1;
        double x2;
        double x3;
    public:
        //Costruttore
        Vettore3D ( double , double , double );
        //Funzioni di selezione
        double Len ();
        
        //Funzioni di INPUT/OUTPUT
        friend ostream & operator<< ( ostream & , const Vettore3D & );
        friend istream & operator>> ( istream & , Vettore3D & );
        
        //Overloading degli operatori binari
        friend Vettore3D operator+ ( const Vettore3D & , const Vettore3D & );
        friend double operator* ( const Vettore3D & , const Vettore3D & );
        friend Vettore3D operator& ( const Vettore3D & , const Vettore3D & );
};

#endif
