//Esercitazione di laboratorio n 0
//Quarto quesito
//Si scriva una funzione che calcola la radice quadrata di un numero reale positivo
//utilizzando il metodo iterativo di Newton. Nel driver si udilizzi la funzione
//di libreria sqrt (dichiarata nel file header cmath) per verificare la correttezza
//tramite confronto del risultato.

//Il metodo di Newton per trovare la radice quadrate di n si basa sulla seguente
//equazione di ricorrenza (con x0 = 1)
// x(k+1) = (xk + n/xk) / 2
//La sequenza viene interrotta quando x(k+1) = xk a meno di una costante e

#include <iostream>
#include <cmath>

using namespace std;

const double epsilon = 0.01;

double mysqrt ( double );

int main () {
    unsigned numero = 10;
    
    cout << "mysqrt ( " << numero << " ): " << mysqrt(numero) << endl;
    cout << "sqrt ( " << numero << " ): " << sqrt(numero) << endl;
    
    system("pause");
    
    return 0;
}

double mysqrt ( double n ) {
    double x0;
    double x1 = 1;
    do {
        x0 = x1;
        x1 = ( x0 + n/x0 ) / 2;
    } while ( abs(x1 - x0) > epsilon );
    return x1;
} 
