#include <iostream>

using namespace std;

const int DIM_VET = 6;
const int NUM_RIGHE = 2;
const int NUM_COL = 3;

int NumeroDistintiVettore(int v[], int n);
int NumeroDistintiMatrice(int m[][NUM_COL], int righe, int col);

int main()
{
  int vett[DIM_VET];
  int mat[NUM_RIGHE][NUM_COL];
  int i, j;

  cout << "Inserisci un vettore di " << DIM_VET << " valori interi : ";
  for (i = 0; i < DIM_VET; i++)
    cin >> vett[i];
  cout << "Il numero di elementi distinti del vettore e' " 
       << NumeroDistintiVettore(vett,DIM_VET) << endl; 

  cout << "Inserisci una matrice di " << NUM_RIGHE 
       << " righe e " << NUM_COL << " colonne" << endl;
  for (i = 0; i < NUM_RIGHE; i++)
    for (j = 0; j < NUM_COL; j++)
      cin >> mat[i][j];

  cout << "Il numero di elementi distinti della matrice e' " 
       << NumeroDistintiMatrice(mat,NUM_RIGHE,NUM_COL) << endl; 

    system("pause");
}

int NumeroDistintiVettore(int v[], int n)
{
  // INSERIRE QUI IL CORPO DELLA FUNZIONE
    int elem[DIM_VET];
    int num = 0;
    bool trovato;
    elem[0] = v[0];
    num = 1;
    for(unsigned i = 1; i < n; i++) {
        //Cerco l'elemento nel vettore di corrispondeze
        trovato = false;
        for(unsigned j = 0; j < num; j++) {
            if(v[i] == elem[j])
                trovato = true;
        }
        if(!trovato) {
            elem[num] = v[i];
            num++;
        }
    }
    return num;
}

int NumeroDistintiMatrice(int m[][NUM_COL], int righe, int col)
{
  // INSERIRE QUI IL CORPO DELLA FUNZIONE
    int elem[NUM_RIGHE*NUM_COL];
    int num = 0;
    bool trovato;
    elem[0] = m[0][0];
    num = 1;
    for(unsigned i = 0; i < NUM_RIGHE; i++) {
        for(unsigned j = 0; j < NUM_COL; j++) {
            //Cerco l'elemento nel vettore di corrispondeze
            trovato = false;
            for(unsigned k = 0; k < num; k++) {
                if(m[i][j] == elem[k])
                    trovato = true;
            }
            if(!trovato) {
                elem[num] = m[i][j];
                num++;
            }
        }
    }
    return num;
}
