#ifndef POLINOMIO_HPP
#define POLINOMIO_HPP

class Polinomio {
    public:
        unsigned elem;
        double *pol;
    
    //public:
        //Costruttori e Distruttore
        Polinomio ( double , unsigned );
        Polinomio ( const Polinomio & );
        ~Polinomio ();
        //Selettori e modificatori
        double Coefficiente ( unsigned );
        //Ridefinizione degli operatori
        void operator= ( const Polinomio & );
        friend Polinomio operator+ ( const Polinomio & , const Polinomio & );
        friend Polinomio operator- ( const Polinomio & , const Polinomio & );
        //Operazioni di input/output
        friend ostream & operator<< ( ostream & , const Polinomio & );
        friend istream & operator>> ( istream & , Polinomio & );
};

#endif
